// header.C 

/***********************************************************************/
/*                                                                     */
/* THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND,  */
/* AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH  */
/* (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL */
/* WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF  */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY       */
/* WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND  */
/* RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR  */
/* NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE    */
/* FOR DAMAGES OF ANY KIND RESULTING FROM ITS USE. Without limiting    */
/* the generality of the foregoing, neither the author, nor JAIR, nor  */
/* JAIR's publishers and distributors, warrant that the Source Code    */
/* will be error-free, will operate without interruption, or will meet */
/* the needs of the user.                                              */
/*                                                                     */
/***********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include "header.H"

Header::Header(char *filename)
{
  static int  i;
  static FILE *fd;
 
  if ((fd = fopen(filename, "r")) == NULL)
  {
    printf("\n  ERROR: cannot open header file %s  (header.C)....\n",
           filename);
    exit (1);
  }
  fscanf(fd, "%d %d %d %d %d", &num_attributes, &num_tr_instances,
         &num_te_instances, &num_precepts, &num_csrules);
  num_states = new float[num_attributes];
  for (i = 0; i < num_attributes; i++)
    fscanf(fd, "%f", &num_states[i]);
  attr_type = new int[num_attributes];
  for (i = 0; i < num_attributes; i++)
    fscanf(fd, "%d", &attr_type[i]);
  fclose(fd);
}

Header::~Header()
{
  delete num_states;
  delete attr_type;
}
