// header.H

/***********************************************************************/
/*                                                                     */
/* THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND,  */
/* AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH  */
/* (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL */
/* WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF  */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY       */
/* WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND  */
/* RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR  */
/* NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE    */
/* FOR DAMAGES OF ANY KIND RESULTING FROM ITS USE. Without limiting    */
/* the generality of the foregoing, neither the author, nor JAIR, nor  */
/* JAIR's publishers and distributors, warrant that the Source Code    */
/* will be error-free, will operate without interruption, or will meet */
/* the needs of the user.                                              */
/*                                                                     */
/***********************************************************************/


// This class reads the header and makes all the information in it
// available to all classes that include it.
// It assumes single-output applications !!

#if !defined(HEADER_H)
#define HEADER_H

#define NOMINAL 0
#define LINEAR 1

class Header 
{
  public:
    Header(char *filename);     // constructor
    ~Header();                  // destructor
    int num_attributes;         // num of attributes 
    int num_tr_instances;       // num of instances in training file
    int num_te_instances;       // num of instances in test file
    int num_precepts;           // num of precepts
    int num_csrules;            // num of cs rules to generate precepts
    float *num_states;          // num of states per var.
    int *attr_type;             // type of attribute
  private:
};

#endif

