// node.H

/***********************************************************************/
/*                                                                     */
/* THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND,  */
/* AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH  */
/* (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL */
/* WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF  */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY       */
/* WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND  */
/* RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR  */
/* NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE    */
/* FOR DAMAGES OF ANY KIND RESULTING FROM ITS USE. Without limiting    */
/* the generality of the foregoing, neither the author, nor JAIR, nor  */
/* JAIR's publishers and distributors, warrant that the Source Code    */
/* will be error-free, will operate without interruption, or will meet */
/* the needs of the user.                                              */
/*                                                                     */
/***********************************************************************/


// This class defines a node as containing a vector and a list of
// vectors that contradict it.

#if !defined(NODE_H)
#define NODE_H

#include "vector.H"

#define MAX_OUTPUT_VALUES 30
#define OFF 0
#define ON  1

class Node
{
  public:
    Node(Vector *I);                // constructor
    float activation(Vector *v);    // activation based on actual distance
    void print();                   // prints node info
    Vector *vector();               // returns vector in node
    ~Node();                        // destructor
    void inc_counters(int ind);
    int counter(int ind);
    void copy_counters(Node *n);
    int max_counter();
    int num_covers;
    int dyn_pty;
  private:
    int counters[MAX_OUTPUT_VALUES];
    Vector *vect;
    typedef struct elc
    {
      Vector *v;
      elc    *next;
    } Elementc;
};

#endif

