// vec_s.H

/***********************************************************************/
/*                                                                     */
/* THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND,  */
/* AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH  */
/* (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL */
/* WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF  */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY       */
/* WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND  */
/* RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR  */
/* NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE    */
/* FOR DAMAGES OF ANY KIND RESULTING FROM ITS USE. Without limiting    */
/* the generality of the foregoing, neither the author, nor JAIR, nor  */
/* JAIR's publishers and distributors, warrant that the Source Code    */
/* will be error-free, will operate without interruption, or will meet */
/* the needs of the user.                                              */
/*                                                                     */
/***********************************************************************/


// This class reads the data file and constructs a list of
// vectors from it.

#if !defined(VECTOR_SET_H)
#define VECTOR_SET_H

#define MARKED  1
#define FREE    0
#define TRAIN   1
#define TEST    2
#define PREC    3
#define CSRULES 4

#include "vector.H"

class Vector_set
{
  public:

    Vector_set();
    void add_vector(Vector *v);
    Vector_set(char *filename, int flag);  // constructor for reading in
                                           // a file
    Vector *get_next_training_vector();    // returns next randomly selected
                                           // training vector
    Vector *get_next_test_vector();  // returns next test vector
    void init();
    void reset_cv();
    Vector *get_next_tr_vector_cv();
    Vector *get_next_te_vector_cv();
    Vector *get_random_vector_cv();
    Vector *get_next_vector();
    ~Vector_set();                         // destructor
  private:
    FILE     *vecf;                        // vector set file
    typedef struct elv 
    {
      Vector *vect;
      int    tag;
      int    cvtag;
      elv    *next;
    } Elementv;
    Elementv *head, *current;
    int num_vectors;
};

#endif

